/*
uniform float enable_correction;
*/
void main(void)
{
	float z, lz, p;
    vec4 ecPosition4 = gl_ModelViewMatrix * gl_Vertex;
    z = - ecPosition4.z;
    if(z > 1.0 /* enable_correction > 0.0 */ )
    {
	    lz = log(z) /* / log(10.0) */;
    	if(lz <= 2.0)
    		p = 1.0 - 0.072 * lz;
    	else if(lz <= 3.0)
    		p = 0.948 - 0.016 * lz;
    	else if(lz <= 4.0)
    		p = 0.99 - 0.03 * lz;
    	else
    		p = 0.87;
    	ecPosition4.z = - pow(z, p);
    }
    gl_Position = gl_ProjectionMatrix * ecPosition4;
}
